!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Allocates global arrays.

subroutine al00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero
  use numerical, only : sqrtmachprec, vsmall
  use fileunits, only : ounit
  use inputlist
  use cputiming
  use allglobal

  use pjhamilto, only : Itor,Gpol,spmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER :: ij, ik, ip, iq, jk, io, imn, jmn, kmn, lmn, llc, imnc, ipq, mnpq, mm, nn, ifail, ii, iofe, nc, npqpq

  BEGIN(al00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Interface geometry;

  RALLOCATE(Rmn,(0:2,1:mn)) ! workspace interpolation array;
  RALLOCATE(Zmn,(0:2,1:mn))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Fourier transforms;

  Nt = max(Ndiscrete*4*Mpol,1) ; Nz = max(Ndiscrete*4*Ntor,1) ; Ntz = Nt*Nz ; soNtz = one/sqrt(one*Ntz) ! discrete resolution; exaggerated discrete resolution;

  RALLOCATE(Rij,(0:9,Ntz)) ! these are used for inverse fft to reconstruct real space geometry from interpolated Fourier harmonics;
  RALLOCATE(Zij,(0:9,Ntz))
  RALLOCATE(sg,(0:3,Ntz))
  RALLOCATE(gij,(1:6,0:3,1:Ntz)) ! need this on higher resolution grid for accurate Fourier decomposition;

  RALLOCATE(glmn,(1:6,mne)) ! workspace for Fourier decomposition of metric terms; see me00ab;

  RALLOCATE(trigm,(1:2*Nt)) ! trignometric factors required for fast Fourier transform;
  RALLOCATE(trign,(1:2*Nz))
  RALLOCATE(trigwk,(1:2*Ntz))

  RALLOCATE(ijreal,(1:Ntz)) ! real space grid;
  RALLOCATE(ijimag,(1:Ntz))
  RALLOCATE(jireal,(1:Ntz))
  RALLOCATE(jiimag,(1:Ntz))

  isr='I' ; ifail=0 ; CALL(C06FUF,( Nt , Nz , ijreal , ijimag , isr , trigm , trign , trigwk , ifail ) ) ; isr='S' ! should be quicker; coefficients dont need to be re-computed;

  FATALMESS(al00aa,ifail.ne.0,error constructing Fourier transform)

  RALLOCATE(ofmn,(1:mne)) ! Fourier harmonics; workspace;
  RALLOCATE(efmn,(1:mne))
  RALLOCATE(sfmn,(1:mne))
  RALLOCATE(cfmn,(1:mne))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Metric information;

  RALLOCATE(agss,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;
  RALLOCATE(agst,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;
  RALLOCATE(agsz,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;
  RALLOCATE(agtt,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;
  RALLOCATE(agtz,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;
  RALLOCATE(agzz,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;
  RALLOCATE(agoo,(1:mn*mn)) ! averaged metric elements; function of s; calculated in me00ab; see ma00aa;

  ALLOCATE(igss,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igst,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igsz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igtt,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igtz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igzz,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(igoo,(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;

  ALLOCATE(sgss,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(sgst,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(sgsz,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(sgtt,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(sgtz,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(sgzz,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;
  ALLOCATE(sgoo,(1:4,0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)) ! type subgrid; geometric information arrays; these are annulus dependent; subgrid allocated in ma00ab;

  RALLOCATE(igaa,(1:4,0:Nofe,0:Nofe,1:mn*mn)) ! geometric information arrays; computed in ma00aa;
  RALLOCATE(igab,(1:6,0:Nofe,0:Nofe,1:mn*mn)) ! geometric information arrays;
  RALLOCATE(igba,(1:6,0:Nofe,0:Nofe,1:mn*mn)) ! geometric information arrays;
  RALLOCATE(igbb,(1:4,0:Nofe,0:Nofe,1:mn*mn)) ! geometric information arrays;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RALLOCATE(felr,(0:1,0:Nofe,0:1,1:Nquad)) ! "left" and "right" finite-element functions;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Enclosed fluxes;

  RALLOCATE(dtflux,(1:Nvol))                       ! \delta \psi_{toroidal} in each annulus;
  RALLOCATE(dpflux,(1:Nvol))                       ! \delta \psi_{poloidal} in each annulus;

  dtflux(1:Nvol) = tflux(1:Nvol) - tflux(0:Nvol-1) ! it is the differential toroidal flux that controls the transform;
  dpflux(1:Nvol) = pflux(1:Nvol) - pflux(0:Nvol-1) ! it is the differential poloidal flux that controls the transform;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Transformation to straight field line angle;

  RALLOCATE(sflangle,(1:Nvol,0:1,1:mns)) ! transformation to straight field line coordinates on interfaces;
  
  RALLOCATE(sfliota,(1:Nvol,0:1)) ! measured rotational transform on inner/outer interfaces in each annulus;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Radial interpolation, radial-sub-grid;

  ALLOCATE(ss,(1:Nvol)) ! type subgrid; prepare interface arrays; global radial coordinate; set in co00aa;

  RALLOCATE(dss,(1:Nvol,-2:Nofe+Nofe)) ! radial sub-grid grid size in each volume, and powers;

  do ll = 1 , Nvol

   RALLOCATE(ss(ll)%s,(0:Ni(ll))) ! radial sub-grid resolution in each annulus;

   if(Ls.eq.0) ss(ll)%s(0:Ni(ll)) = (           (ll-1)  + (/ (ii,ii=0,Ni(ll)) /) * one / Ni(ll) * (                one                  ) ) /            Nvol
   if(Ls.eq.1) ss(ll)%s(0:Ni(ll)) = (      tflux(ll-1)  + (/ (ii,ii=0,Ni(ll)) /) * one / Ni(ll) * (      tflux(ll)  -      tflux(ll-1)  ) ) /      tflux(Nvol)
   if(Ls.eq.2) ss(ll)%s(0:Ni(ll)) = ( sqrt(tflux(ll-1)) + (/ (ii,ii=0,Ni(ll)) /) * one / Ni(ll) * ( sqrt(tflux(ll)) - sqrt(tflux(ll-1)) ) ) / sqrt(tflux(Nvol))

   dss(ll,1) = ( ss(ll)%s(Ni(ll)) - ss(ll)%s(0) ) / Ni(ll) ! for equally spaced radial sub-grid;

   do iofe = -2,Nofe+Nofe ; dss(ll,iofe) = dss(ll,1)**(iofe)
   enddo

  enddo

  RALLOCATE(iss,(0:Nvol)) ! an array of this format is required for NAG routine E01BEF;

  do ll = 1 , Nvol ; iss(ll-1)=ss(ll)%s(0) ; iss(ll)=ss(ll)%s(Ni(ll))
  enddo
  
  do ll = 1 , Nvol ; FATAL(global,iss(ll-1).ge.iss(ll)) ! radial coordinate must be monotonic increasing;
  enddo

  rho = ss(1)%s(1) ! matching; see ma01ae; only required in innermost volume, myid=0;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Regularity matching conditions; see ma01ae for definition; the Ajpq and Bjpq are used in ma00aa;

  if( myid.eq.0 ) then ! only the innermost volume requires Ajpq and Bjpq;
   
   FATALMESS(al00aa,Nofe.gt.3,have not yet implemented regularity matching condition)
   
   RALLOCATE(Ajpq,(1:mn,0:Nofe,0:Nofe))
   RALLOCATE(Bjpq,(1:mn,0:Nofe,0:Nofe))
   
   do ij = 1 , mn ; mm = im(ij) ; nn = in(ij)
    do ip = 0 , Nofe
     do iq = 0 , Nofe
      
      if( Lrho ) then
       
       if( ip.eq.0                       ) Ajpq(ij,ip,iq) = rho**(2+2*iq+0)
       if( ip.eq.1                       ) Ajpq(ij,ip,iq) = rho**(2+2*iq-1) * (mm+2+2*iq+0)
       if( ip.eq.2                       ) Ajpq(ij,ip,iq) = rho**(2+2*iq-2) * (mm+2+2*iq+0) * (mm+2+2*iq-1)
       if( ip.eq.3 .and. mm+2+2*iq-3.ge.0) Ajpq(ij,ip,iq) = rho**(2+2*iq-3) * (mm+2+2*iq+0) * (mm+2+2*iq-1) * (mm+2+2*iq-2)
       
       if( ip.eq.0                       ) Bjpq(ij,ip,iq) = rho**(0+2*iq+0)
       if( ip.eq.1 .and. mm+0+2*iq-1.ge.0) Bjpq(ij,ip,iq) = rho**(0+2*iq-1) * (mm+0+2*iq+0)
       if( ip.eq.2 .and. mm+0+2*iq-2.ge.0) Bjpq(ij,ip,iq) = rho**(0+2*iq-2) * (mm+0+2*iq+0) * (mm+0+2*iq-1)
       if( ip.eq.3 .and. mm+0+2*iq-3.ge.0) Bjpq(ij,ip,iq) = rho**(0+2*iq-3) * (mm+0+2*iq+0) * (mm+0+2*iq-1) * (mm+0+2*iq-2)
       
      else
       
       if( ip.eq.0                     ) Ajpq(ij,ip,iq) = rho**(mm+2*iq+2)
       if( ip.eq.1                     ) Ajpq(ij,ip,iq) = rho**(mm+2*iq+1) * (mm+2*iq+2)
       if( ip.eq.2                     ) Ajpq(ij,ip,iq) = rho**(mm+2*iq  ) * (mm+2*iq+2) * (mm+2*iq+1)
       if( ip.eq.3 .and. mm+2*iq-1.ge.0) Ajpq(ij,ip,iq) = rho**(mm+2*iq-1) * (mm+2*iq+2) * (mm+2*iq+1) * (mm+2*iq  )
       
       if( ip.eq.0                     ) Bjpq(ij,ip,iq) = rho**(mm+2*iq  )
       if( ip.eq.1 .and. mm+2*iq-1.ge.0) Bjpq(ij,ip,iq) = rho**(mm+2*iq-1) * (mm+2*iq  )
       if( ip.eq.2 .and. mm+2*iq-2.ge.0) Bjpq(ij,ip,iq) = rho**(mm+2*iq-2) * (mm+2*iq  ) * (mm+2*iq-1)
       if( ip.eq.3 .and. mm+2*iq-3.ge.0) Bjpq(ij,ip,iq) = rho**(mm+2*iq-3) * (mm+2*iq  ) * (mm+2*iq-1) * (mm+2*iq-2)
       
      endif ! end of if( Lrho );
      
     enddo ! end of do iq;
    enddo ! end of do ip;
    
    if( Wal00aa ) then
     
     cput = MPI_WTIME() 
     
     do ip = 0 , Nofe
      write(ounit,'("al00aa : "f10.2" : myid="i3" : m="i3" ; n="i3" ; Ajpq("i3","i1",0:"i1")="99es23.15)')cput-cpus,myid,im(ij),in(ij),ij,ip,Nofe,Ajpq(ij,ip,0:Nofe)
     enddo
     write(ounit,'("al00aa : "f10.2" :")')cput-cpus

     do ip = 0 , Nofe
      write(ounit,'("al00aa : "f10.2" : myid="i3" : m="i3" ; n="i3" ; Bjpq("i3","i1",0:"i1")="99es23.15)')cput-cpus,myid,im(ij),in(ij),ij,ip,Nofe,Bjpq(ij,ip,0:Nofe)
     enddo
     write(ounit,'("al00aa : "f10.2" :")')cput-cpus

    endif ! end of if( Wal00aa );
    
   enddo ! end of do ij;
  
  endif

!  RALLOCATE(Ajip,(1:mn,0:Nofe,0:Nofe))
!  RALLOCATE(Bjip,(1:mn,0:Nofe,0:Nofe))
!  
!  rho = ss(1)%s(1) ! innermost volume, innermost sub-grid point;
!  
!  if( abs(rho-dss(1,1)).gt.vsmall ) write(ounit,'("al00aa : "f10.2" : myid="i3" ; WARNING ; rho="es23.15" ; dss(1,1)="es23.15" ;")')cput-cpus,myid,rho,dss(1,1)
!
!  if( Wal00aa ) then ; cput = MPI_WTIME() ; write(ounit,'("al00aa : "f10.2" : myid="i3" ; constructing Ajip and Bjip ;")')cput-cpus,myid
!  endif
!
!  select case(Nofe)
!  case(2) ! piecewise quintic;
!  
!  do ij = 1 , mn ; mm = im(ij)
!
!   Ajip(ij,0,0) =   ( 24 + 10*mm + mm**2 ) * rho**(-2-mm) / 8 ; Ajip(ij,0,1) = - ( 9 + 2*mm ) * rho**(-1-mm) / 8 ; Ajip(ij,0,2) =   rho**(-0-mm) / 8
!   Ajip(ij,1,0) = - ( 12 +  8*mm + mm**2 ) * rho**(-4-mm) / 4 ; Ajip(ij,1,1) =   ( 7 + 2*mm ) * rho**(-3-mm) / 4 ; Ajip(ij,1,2) = - rho**(-2-mm) / 4
!   Ajip(ij,2,0) =   (  8 +  6*mm + mm**2 ) * rho**(-6-mm) / 8 ; Ajip(ij,2,1) = - ( 5 + 2*mm ) * rho**(-5-mm) / 8 ; Ajip(ij,2,2) =   rho**(-4-mm) / 8
!
!   FATAL(al00aa,mm.lt.0)
!
!   if( mm.eq.0 ) then
!   Bjip(ij,0,0) = 1 ; Bjip(ij,0,1) = -5 * rho**( 1) / 8 ; Bjip(ij,0,2) =   rho**( 2) / 8
!   Bjip(ij,1,0) = 0 ; Bjip(ij,1,1) =  3 * rho**(-1) / 4 ; Bjip(ij,1,2) = - rho**( 0) / 4
!   Bjip(ij,2,0) = 0 ; Bjip(ij,2,1) = -1 * rho**(-3) / 8 ; Bjip(ij,2,2) =   rho**(-2) / 8
!   endif
!
!   if( mm.eq.1 ) then
!   Bjip(ij,0,0) =   15 * rho**(-1) / 8 ; Bjip(ij,0,1) = - 7 * rho**( 0) / 8 ; Bjip(ij,0,2) =   rho**( 1) / 8
!   Bjip(ij,1,0) = -  5 * rho**(-3) / 4 ; Bjip(ij,1,1) =   5 * rho**(-2) / 4 ; Bjip(ij,1,2) = - rho**(-1) / 4
!   Bjip(ij,2,0) =    3 * rho**(-5) / 8 ; Bjip(ij,2,1) = - 3 * rho**(-4) / 8 ; Bjip(ij,2,2) =   rho**(-3) / 8
!   endif
!
!   if( mm.gt.1 ) then
!   Bjip(ij,0,0) = ( 8 + 6 * mm + mm**2 ) * rho**(-0-mm) / 8 ; Bjip(ij,0,1) = - ( 5 + 2 * mm ) * rho**( 1-mm) / 8 ; Bjip(ij,0,2) =   rho**( 2-mm) / 8
!   Bjip(ij,1,0) = (   - 4 * mm - mm**2 ) * rho**(-2-mm) / 4 ; Bjip(ij,1,1) = + ( 3 + 2 * mm ) * rho**(-1-mm) / 4 ; Bjip(ij,1,2) = - rho**(  -mm) / 4
!   Bjip(ij,2,0) = (   + 2 * mm + mm**2 ) * rho**(-4-mm) / 8 ; Bjip(ij,2,1) = - ( 1 + 2 * mm ) * rho**(-3-mm) / 8 ; Bjip(ij,2,2) =   rho**(-2-mm) / 8
!   endif
!
!  enddo
!  
!  case default
!   FATALMESS(al00aa,.true.,have not yet constructed coordinate regularity matching conditions : choose different Nofe)
!  end select
!
!  if( Wal00aa ) then ; cput = MPI_WTIME() ; write(ounit,'("al00aa : "f10.2" : myid="i3" ; constructed  Ajip and Bjip ;")')cput-cpus,myid
!  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Spectral width constraints;

  RALLOCATE(swI,(1:Ntz)) ! workspace for spectral-condensation force;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Construction of `force'

  RALLOCATE(Bomn,(1:Nvol,0:1,1:mn))
  RALLOCATE(Iomn,(1:Nvol,1:mn))

  RALLOCATE(Bdmn,(0:1,1:mn))
  RALLOCATE(Idmn,(1:mn))

  RALLOCATE(mBomn,(1:Nvol-1))
  RALLOCATE(mIomn,(1:Nvol-1))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Parallel construction of derivative matrix;

  RALLOCATE(oRbc,(0:Nvol,1:mn)) ! used in fc00aa when constructing derivatives wrt interface Fourier geometry;
  RALLOCATE(oZbs,(0:Nvol,1:mn))

  IALLOCATE(RZl,(1:Nvol,0:1)) ! the Beltrami field in the ll-th volume depends on the RZl(ll,0), . . ., RZl(ll,1) interfaces; 

!  do ll = 1,Nvol
!
!   if    ( ll.eq.1 ) then ; RZl(ll,0:1) = (/    1  , min( max(   3,1+iextrap) , Nvol-1 ) /) ! note: ll=1    interface depends on ll=2,3,.. by extrapolation;
!   elseif( ll.eq.2 ) then ; RZl(ll,0:1) = (/    2  , min( max(   3,1+iextrap) , Nvol-1 ) /) ! note: ll=1    interface depends on ll=2,3,.. by extrapolation;
!   elseif( ll.eq.3 ) then ; RZl(ll,0:1) = (/    2  , min( max(   4,1+iextrap) , Nvol-1 ) /)
!   elseif( ll.ge.4 ) then ; RZl(ll,0:1) = (/ ll-2  , min(     ll+1            , Nvol-1 ) /) ! note: ll=Nvol interface is not a degree-of-freedom;
!   endif
!
!  enddo

  do ll = 1,Nvol ; RZl(ll,0:1) = (/  max(ll-1,1)  ,  min(ll+1,Nvol-1)  /) ! force balance at I_{l} depends on I_{l-1} and I_{l+1}; need to check fc01a;;
  enddo

  RALLOCATE(dIdRZ,(1:Nvol,1:mn,1:mn+mn-1))

  ALLOCATE(dBd,(1:Nvol,0:1)) ! this is a structure;

  do ll = 1 , Nvol
   do io = 0 , 1
!if( ll.eq.   2 .and. io.eq.0 ) cycle
!if( ll.eq.Nvol .and. io.eq.1 ) cycle
    ALLOCATE(dBd(ll,io)%mnllRZ,(1:mn,RZl(ll,0):RZl(ll,1),1:mn+mn-1))
   enddo
  enddo
  
!  if( myid.eq.0 ) then
!   ALLOCATE(HH,(1:nHnz))
!   ALLOCATE(hrow,(1:nHnz))
!   ALLOCATE(hcol,(1:nHnz))
  if( Lc05pdf .or. Lcompare .or. Levalues .or. Levectors ) then ; RALLOCATE(pHess,(1:Ngdof,1:Ngdof)) ! fc00aa will calculate the "Hessian" matrix in parallel;
  endif
!  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Trigonometric factors;

  IALLOCATE(ijk,(1:mn,1:mn))

  jk = 0

  do ij = 1 , mn
   do ik = 1 , mn ; jk = jk + 1 ! count;

    ijk(ij,ik) = jk

    FATAL(al00aa,jk.ne.ik + (ij-1) * mn)

   enddo
  enddo

  FATAL(al00aa,jk.ne.mn*mn)


  if( Lsymagl ) then ; RALLOCATE(srigfac,(1:4,1:mne,1:mn*mn)) ! used in me00ab;
  else               ; RALLOCATE(trigfac,(1:4,1:mne,1:mn*mn)) ! used in me00ab;
  endif
  
  jk = 0 

  do ij = 1 , mn
   do ik = 1 , mn ; jk = jk + 1

    do ip = 1 , mne ! enhanced resolution for gij / sqrt g;

     if( Lsymagl )  then
      
      if ( im(ij) + ime(ip) + im(ik).eq.0 .and. in(ij) + ine(ip) + in(ik).eq.0 ) srigfac(1:4,ip,jk) = srigfac(1:4,ip,jk) + (/-1,-1, 0,+1/)
      if ( im(ij) + ime(ip) - im(ik).eq.0 .and. in(ij) + ine(ip) - in(ik).eq.0 ) srigfac(1:4,ip,jk) = srigfac(1:4,ip,jk) + (/+1, 0,-1,+1/)
      if ( im(ij) - ime(ip) + im(ik).eq.0 .and. in(ij) - ine(ip) + in(ik).eq.0 ) srigfac(1:4,ip,jk) = srigfac(1:4,ip,jk) + (/-1,+1, 0,+1/)
      if ( im(ij) - ime(ip) - im(ik).eq.0 .and. in(ij) - ine(ip) - in(ik).eq.0 ) srigfac(1:4,ip,jk) = srigfac(1:4,ip,jk) + (/+1, 0,+1,+1/)
      
      else
      
      if ( im(ij) + ime(ip) + im(ik).eq.0 .and. in(ij) + ine(ip) + in(ik).eq.0 ) trigfac(1:4,ip,jk) = trigfac(1:4,ip,jk) + (/-1,-1, 0,+1/)
      if ( im(ij) + ime(ip) - im(ik).eq.0 .and. in(ij) + ine(ip) - in(ik).eq.0 ) trigfac(1:4,ip,jk) = trigfac(1:4,ip,jk) + (/+1,-1, 0,+1/)
      if ( im(ij) - ime(ip) + im(ik).eq.0 .and. in(ij) - ine(ip) + in(ik).eq.0 ) trigfac(1:4,ip,jk) = trigfac(1:4,ip,jk) + (/-1,+1, 0,+1/)
      if ( im(ij) - ime(ip) - im(ik).eq.0 .and. in(ij) - ine(ip) - in(ik).eq.0 ) trigfac(1:4,ip,jk) = trigfac(1:4,ip,jk) + (/+1,+1, 0,+1/)
      
     endif

    enddo

   enddo ! end of do ik = 1,mn;
  enddo ! end of do ij = 1,mn ;

  RALLOCATE(sgl,(1:9,1:mn*mn)) 

  IALLOCATE(aijk,(1:mn,1:mn,1:mn))
  IALLOCATE(bijk,(1:mn,1:mn,1:mn))

  IALLOCATE(aijkl,(1:mn,1:mn,1:mn,1:mn))
  IALLOCATE(bijkl,(1:mn,1:mn,1:mn,1:mn))

  do imn = 1,mn
   do jmn = 1,mn
    do kmn = 1,mn

     if( im(imn)+im(jmn)+im(kmn).eq.0 .and. in(imn)+in(jmn)+in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
                                                                                  bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) - im(jmn)
     endif

     if( im(imn)+im(jmn)-im(kmn).eq.0 .and. in(imn)+in(jmn)-in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
                                                                                  bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) + im(jmn)
     endif

     if( im(imn)-im(jmn)+im(kmn).eq.0 .and. in(imn)-in(jmn)+in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
                                                                                  bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) + im(jmn)
     endif

     if( im(imn)-im(jmn)-im(kmn).eq.0 .and. in(imn)-in(jmn)-in(kmn).eq.0 ) then ; aijk(imn,jmn,kmn) = aijk(imn,jmn,kmn) + im(kmn)
                                                                                  bijk(imn,jmn,kmn) = bijk(imn,jmn,kmn) - im(jmn)
     endif

     do lmn = 1,mn

      if( im(imn)+im(jmn)+im(kmn)+im(lmn).eq.0 .and. in(imn)+in(jmn)+in(kmn)+in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) - im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif

      if( im(imn)+im(jmn)+im(kmn)-im(lmn).eq.0 .and. in(imn)+in(jmn)+in(kmn)-in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) + im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif

      if( im(imn)+im(jmn)-im(kmn)+im(lmn).eq.0 .and. in(imn)+in(jmn)-in(kmn)+in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) + im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif
 
      if( im(imn)+im(jmn)-im(kmn)-im(lmn).eq.0 .and. in(imn)+in(jmn)-in(kmn)-in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) - im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif

      if( im(imn)-im(jmn)+im(kmn)+im(lmn).eq.0 .and. in(imn)-in(jmn)+in(kmn)+in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) - im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif

      if( im(imn)-im(jmn)+im(kmn)-im(lmn).eq.0 .and. in(imn)-in(jmn)+in(kmn)-in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) + im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif

      if( im(imn)-im(jmn)-im(kmn)+im(lmn).eq.0 .and. in(imn)-in(jmn)-in(kmn)+in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) + im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif
 
      if( im(imn)-im(jmn)-im(kmn)-im(lmn).eq.0 .and. in(imn)-in(jmn)-in(kmn)-in(lmn).eq.0 ) then ; aijkl(imn,jmn,kmn,lmn) = aijkl(imn,jmn,kmn,lmn) - im(lmn)
                                                                                                   bijkl(imn,jmn,kmn,lmn) = bijkl(imn,jmn,kmn,lmn) + im(lmn)
      endif

     enddo

    enddo
   enddo
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Volume integrals

  RALLOCATE(Fenergy,(0:Ngdof))

  RALLOCATE(volume,(0:2,1:Nvol)) ! volume of annular regions;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following is required for the sparse representation of the Hessian;

!  nHnz=0 !; icon = 0
!
!  do llc = 2,Nvol-1
!
!   do imnc = 1,mn !; icon = icon+1
!    do iRZl = minval( RZl(llc:llc+1,0) ) , maxval( RZl(llc:llc+1,1) )
!     do iRZ = 1,0,-1
!      do imn = 1,mn
!       if( iRZ.eq.1 .and. imn.eq.1 ) cycle ! nothing depends on Zmn_{0,0}
!!idof = ( iRZl - 2 ) * ( mn + mn - 1 ) + iRZ * mn + imn - iRZ ! label degree of freedom;
!       nHnz = nHnz+1
!      enddo
!     enddo
!    enddo
!   enddo
!
!   do imnc = 2,mn ! icon = icon+1
!    do iRZl = llc,llc ! not really a loop; just to be consistent with above;
!     do iRZ = 1,0,-1
!      do imn = 1,mn
!       if( iRZ.eq.1 .and. imn.eq.1 ) cycle ! nothing depends on Zmn_{0,0}
!!idof = ( iRZl - 2 ) * ( mn + mn - 1 ) + iRZ * mn + imn - iRZ ! label degree of freedom;
!       nHnz = nHnz+1
!      enddo
!     enddo
!    enddo
!   enddo
!
!  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Periodic orbits;

  ALLOCATE(pqorbit,(1:Nvol,maxval(npq))) ! periodic orbits;

  pqorbit(1:Nvol,1:maxval(npq))%so = - one ! set invalid initial guesss; will be updated in pq01aa;

  do ll = 1 , Nvol ! prepare workspace for constructing periodic orbits;
   
  !if( myid.ne.modulo(ll-1,numprocs) ) cycle ! this cycle statement can probably be reinserted -- periodic orbits are no longer broadcast;
   
   FATAL(readin,npq(ll).gt.0.and.q1(ll).eq.0)

   if( npq(ll).ge.1 ) then ; pqorbit(ll,1)%pq(1:2) = (/p1(ll),q1(ll)/) ; pqorbit(ll,1)%res = 99.99
   endif

   FATAL(readin,npq(ll).gt.1.and.q2(ll).eq.0)

   if( npq(ll).ge.2 ) then ; pqorbit(ll,2)%pq(1:2) = (/p2(ll),q2(ll)/) ; pqorbit(ll,2)%res = 99.99
   endif
   
   npqpq = abs( p1(ll)*q2(ll) - q1(ll)*p2(ll) )
   FATAL(readin,npq(ll).gt.2.and.npqpq.ne.1)

   do nc = 3,npq(ll)
    pqorbit(ll,nc)%pq(1:2) = pqorbit(ll,nc-2)%pq(1:2) + pqorbit(ll,nc-1)%pq(1:2) ; pqorbit(ll,nc)%res=99.99 ! noble convergents;
   enddo
   
   if( myid.ne.modulo(ll-1,numprocs) ) cycle
   
   do nc = 1,npq(ll) !; q=pqorbit(ll,nc)%pq(2)
    RALLOCATE(pqorbit(ll,nc)%s,(0:pqorbit(ll,nc)%pq(2)))
    RALLOCATE(pqorbit(ll,nc)%t,(0:pqorbit(ll,nc)%pq(2)))
    RALLOCATE(pqorbit(ll,nc)%a,(0:pqorbit(ll,nc)%pq(2)))    
   enddo
   
  enddo ! end of do ll = 1 , Nvol

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Quadratic-flux minimizing surfaces;  

  mnpq = max(1,maxval(npq)) ! perhaps this should be maxval(npq(1:Nvol)) ?;

  ALLOCATE(qfms,(1:Nvol,mnpq))

  do ll = 1 , Nvol
   do ipq = 1 , mnpq
    qfms(ll,ipq)%i = 0 ; qfms(ll,ipq)%pq(1:2) = (/ 0 , 0 /) ! intialize; these are given values in pq02aa;
   enddo
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! Irrational surfaces;

  if( Mirrits.gt.0 ) then ! prepare workspace for construction of irrational surfaces;

   irrmn = irrNtor+1 + irrMpol * (2*irrNtor+1) ! set total number of Fourier harmonics for irrational surfaces;

   IALLOCATE(irrim,(1:irrmn)) ! poloidal modes for irrational surfaces;
   IALLOCATE(irrin,(1:irrmn)) ! toroidal modes for irrational surfaces;

   CALL(gi00ab,(irrMpol,irrNtor,Nfp,irrmn,irrim,irrin))

   RALLOCATE(irrsurf%tm,(0:irrMpol)) ! these are given values in pq01aa;
   RALLOCATE(irrsurf%sm,(0:irrMpol)) ! these are given values in pq01aa;
   RALLOCATE(irrsurf%Rbc,(1:irrmn)) ! these are given values in ir00aa;
   RALLOCATE(irrsurf%Zbs,(1:irrmn)) ! these are given values in ir00aa;
   RALLOCATE(irrsurf%fmn,(1:irrmn)) ! these are given values in ir00aa;

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Lsetmupf .and. Lwrpj ) then ! allocate array used to hold surface potentials on inner/outer of each interface;
   RALLOCATE(Itor,(1:Nvol,0:1))
   RALLOCATE(Gpol,(1:Nvol,0:1))
   RALLOCATE(spmn,(1:Nvol,0:1,1:mn))
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(al00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine al00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
