!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!latex \item Pressure-jump Hamiltonian o.d.e.'s,
!latex and tangent map,
!latex derived from the Hamiltonian \be H \equiv 2 \, \delta p =  2 ( p_1 - p_2 ) = B_2^2 - B_1^2 \ee
!latex where, for Beltrami fields, the magnitude of $B$ on flux surfaces (assume that $B^s=0$) may be written \be 
!latex B^2 = \frac{g_{\phi\phi} f_\theta f_\theta - 2 g_{\theta\phi}f_\theta f_\phi + g_{\theta\theta} f_\phi f_\phi}{g_{\theta\theta}g_{\phi\phi}-g_{\theta\phi}g_{\theta\phi}}
!latex \ee
!latex where $f$ is a surface potential and $g_{\theta\theta}$, $g_{\theta\phi}$ and $g_{\phi\phi}$ are metric elements local to the interface.
!latex \item Assuming that the field $B_1$ is known on the `inside' of the interface, ie. $B_{1\theta}=f_\theta$, $B_{1\phi}=f_\phi$ and $f$ is known, 
!latex it is required to determine the tangential field, $p_\theta = B_\theta$ and $p_\phi = B_\phi$, on the `outside' of the interface.
!latex \item The o.d.e.'s are given by Hamilton's equations \be
!latex \dot \theta   =  \frac{\partial H}{\partial p_\theta}\Big|_{\theta,\phi,p_\phi}, \qquad
!latex \dot p_\theta = -\frac{\partial H}{\partial \theta}\Big|_{p_\theta,\phi,p_\phi}, \qquad
!latex \dot \phi     =  \frac{\partial H}{\partial p_\phi}\Big|_{\theta,p_\theta,\phi}, \qquad
!latex \dot p_\phi   = -\frac{\partial H}{\partial \phi}\Big|_{\theta,p_\theta,p_\phi}, \ee
!latex where the `dot' denotes derivative with respect to `time'.
!latex \item This is reduced to a $1\frac{1}{2}$ dimensional system by using $\phi$ as the time-like integration parameter, and replacing the equation for $\dot p_\phi$ with 
!latex \be p_\phi= P(\theta,p_\theta,\phi; \delta p) = \frac{-b\pm\sqrt{b^2-4ac}}{2a} \label{eq:pphi} \ee
!latex where \mbox{$a=g_{\theta\theta}$}, \mbox{$b=-2 g_{\theta\phi}p_\theta$} 
!latex and \mbox{$c=g_{\phi\phi} p_{\theta}^2 - b_1 - 2 \, \delta p \, G$} (see below for definition of $b_1$ and $G$).
!latex \item The o.d.e.'s that then need to be followed are (see below for definition of $A$ and $b_2$) \be
!latex \frac{d   \theta}{d\phi}&=& \frac{g_{\phi\phi} p_{\theta} - g_{\theta\phi} p_{\phi}}{-g_{\theta\phi}p_{\theta}+g_{\theta\theta}p_{\phi}},\\
!latex \frac{d p_\theta}{d\phi}&=& \frac{g_{\phi\phi,\theta} (f_{\theta}^2-p_{\theta}^2)-2g_{\theta\phi,\theta}(f_{\theta}f_{\phi}-p_{\theta}p_{\phi})
!latex +g_{\theta\theta,\theta}(f_{\phi}^2-p_{\phi}^2)+A+(b_2-b_1)G_{,\theta} / G }
!latex {-2g_{\theta\phi}p_\theta+g_{\theta\theta}2p_{\phi}}. \ee

!latex \item Note that $d\theta / d \phi = B^\theta / B^\phi $; there is a fundamental relation between the pressure-jump Hamiltonian and the field-line Hamiltonian. 
!latex (Furthermore, in many cases the surface will be given in straight field line coordinates, so $d \theta / d\phi = const.$.)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine ph00aa( phi , ptt , dptt )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  use constants
  use fileunits, only : ounit
  use inputlist, only : Wph00aa, pres, pscale
  use allglobal, only : myid,numprocs,ll,cpus,mn,im,in,Rbc,Zbs

  use pjhamilto, only : Itor,Gpol,spmn,io

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  LOCALS

  REAL,intent(in) :: phi,ptt(6)
  REAL,intent(out) :: dptt(6)

  INTEGER,parameter :: plusminus=1

  REAL :: delta_p

  INTEGER :: imn,ioi

  REAL :: cs(2),arg,pt,pp
  REAL :: dBB1(0:2),dBB2(0:3),a,b,c,discrim

  REAL :: dR(0:3,0:3,0:3),dZ(0:3,0:3,0:3),df(0:3,0:3,0:3),gl(3,3,0:3,0:3),dG(0:2),dA(0:1),db1(0:3),dabc(3,0:2),dP(0:2),db2(0:2)
  REAL :: ftftptpt,ftfpptpp,fpfppppp
  REAL :: dtdot(0:2),dpdot(0:2),dsdot(0:2),TM(2,2)
  
  BEGIN(ph00aa)
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
!latex \item The conserved `energy' $\delta p$ is given by the jump in pressure across the interface.

  if( io.eq.0 ) delta_p = ( pres(ll) - pres(ll-1) ) * pscale
  if( io.eq.1 ) delta_p = ( pres(ll) - pres(ll+1) ) * pscale
  
  ioi = ll+io-1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  pt = ptt(1) ! shorthand; "momentum" coordinate;
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  dR=zero ; dZ=zero ; df=zero ; df(2,0,0)=Itor(ll,io) ; df(3,0,0)=Gpol(ll,io)
  
  do imn = 1,mn ; arg = im(imn)*ptt(2)-in(imn)*phi ; cs = (/cos(arg),sin(arg)/)
   
   dR(0,0,0) = dR(0,0,0) + Rbc(ioi,0,imn)*cs(1)
   
   dR(2,0,0) = dR(2,0,0) + Rbc(ioi,0,imn)*cs(2)*(-im(imn))
   dR(3,0,0) = dR(3,0,0) + Rbc(ioi,0,imn)*cs(2)*(+in(imn))
   
   dR(2,2,0) = dR(2,2,0) + Rbc(ioi,0,imn)*cs(1)*(-im(imn))*(+im(imn))
   dR(3,2,0) = dR(3,2,0) + Rbc(ioi,0,imn)*cs(1)*(+in(imn))*(+im(imn))
   
   dR(2,2,2) = dR(2,2,2) + Rbc(ioi,0,imn)*cs(2)*(-im(imn))*(+im(imn))*(-im(imn))
   dR(3,2,2) = dR(3,2,2) + Rbc(ioi,0,imn)*cs(2)*(+in(imn))*(+im(imn))*(-im(imn))
   
!  dZ(0,0,0) = dZ(0,0,0) + Zbs(ioi,0,imn)*cs(2)
   
   dZ(2,0,0) = dZ(2,0,0) + Zbs(ioi,0,imn)*cs(1)*(+im(imn))
   dZ(3,0,0) = dZ(3,0,0) + Zbs(ioi,0,imn)*cs(1)*(-in(imn))
   
   dZ(2,2,0) = dZ(2,2,0) + Zbs(ioi,0,imn)*cs(2)*(+im(imn))*(-im(imn))
   dZ(3,2,0) = dZ(3,2,0) + Zbs(ioi,0,imn)*cs(2)*(-in(imn))*(-im(imn))
   
   dZ(2,2,2) = dZ(2,2,2) + Zbs(ioi,0,imn)*cs(1)*(+im(imn))*(-im(imn))*(+im(imn))
   dZ(3,2,2) = dZ(3,2,2) + Zbs(ioi,0,imn)*cs(1)*(-in(imn))*(-im(imn))*(+im(imn))
   
!df(0,0,0) = df(0,0,0)+spmn(ll,io,imn)*cs(2)
   
   df(2,0,0) = df(2,0,0)+spmn(ll,io,imn)*cs(1)*(+im(imn))
   df(3,0,0) = df(3,0,0)+spmn(ll,io,imn)*cs(1)*(-in(imn))

   df(2,2,0) = df(2,2,0)+spmn(ll,io,imn)*cs(2)*(+im(imn))*(-im(imn))
   df(3,2,0) = df(3,2,0)+spmn(ll,io,imn)*cs(2)*(-in(imn))*(-im(imn))
   
   df(2,2,2) = df(2,2,2)+spmn(ll,io,imn)*cs(1)*(+im(imn))*(-im(imn))*(+im(imn))
   df(3,2,2) = df(3,2,2)+spmn(ll,io,imn)*cs(1)*(-in(imn))*(-im(imn))*(+im(imn))
   
  enddo
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
  gl(2,2,0,0)=         dR(2,0,0)*dR(2,0,0)                       + dZ(2,0,0)*dZ(2,0,0)
  gl(2,2,2,0)= two * ( dR(2,0,0)*dR(2,2,0)                       + dZ(2,0,0)*dZ(2,2,0))
  gl(2,2,2,2)= two * ( dR(2,2,0)*dR(2,2,0) + dR(2,0,0)*dR(2,2,2) + dZ(2,2,0)*dZ(2,2,0) + dZ(2,0,0)*dZ(2,2,2))

  gl(2,3,0,0)= dR(2,0,0)*dR(3,0,0)                                                                   + dZ(2,0,0)*dZ(3,0,0)
  gl(2,3,2,0)= dR(2,2,0)*dR(3,0,0)                       + dR(2,0,0)*dR(3,2,0)                       + dZ(2,2,0)*dZ(3,0,0)                       + dZ(2,0,0)*dZ(3,2,0)
  gl(2,3,2,2)= dR(2,2,2)*dR(3,0,0) + dR(2,2,0)*dR(3,2,0) + dR(2,2,0)*dR(3,2,0) + dR(2,0,0)*dR(3,2,2) &
             + dZ(2,2,2)*dZ(3,0,0) + dZ(2,2,0)*dZ(3,2,0) + dZ(2,2,0)*dZ(3,2,0) + dZ(2,0,0)*dZ(3,2,2)

  gl(3,3,0,0)=         dR(3,0,0)*dR(3,0,0)                       + dR(0,0,0)*dR(0,0,0)                       + dZ(3,0,0)*dZ(0,0,0)
  gl(3,3,2,0)= two * ( dR(3,0,0)*dR(3,2,0)                       + dR(0,0,0)*dR(2,0,0)                       + dZ(3,0,0)*dZ(3,2,0)                       )
  gl(3,3,2,2)= two * ( dR(3,2,0)*dR(3,2,0) + dR(3,0,0)*dR(3,2,2) + dR(2,0,0)*dR(2,0,0) + dR(0,0,0)*dR(2,2,0) + dZ(3,2,0)*dZ(3,2,0) + dZ(3,0,0)*dZ(3,2,2) )
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!latex \item Some description of the internal notation follows :
!latex \be G = g_{\theta\theta} g_{\phi\phi} - g_{\theta\phi} g_{\theta\phi}, \ee

   dG(0)= gl(2,2,0,0)*gl(3,3,0,0)                                                                               -         gl(2,3,0,0)**2
   dG(1)= gl(2,2,2,0)*gl(3,3,0,0)                           + gl(2,2,0,0)*gl(3,3,2,0)                           - two *   gl(2,3,0,0)*gl(2,3,2,0)
   dG(2)= gl(2,2,2,2)*gl(3,3,0,0) + gl(2,2,2,0)*gl(3,3,2,0) + gl(2,2,2,0)*gl(3,3,2,0) + gl(2,2,0,0)*gl(3,3,2,2) - two * ( gl(2,3,2,0)*gl(2,3,2,0) + gl(2,3,0,0)*gl(2,3,2,2) )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!latex \be A = g_{\phi\phi} 2 f_{\theta} f_{\theta\theta} - 2 g_{\theta\phi} ( f_{\theta\theta} f_{\phi} + f_{\theta} f_{\phi\theta} ) 
!latex + g_{\theta\theta} 2 f_{\phi} f_{\phi\theta}, \ee

   dA(0) = gl(3,3,0,0)*two*df(2,0,0)*df(2,2,0)&
         - two*gl(2,3,0,0)*( df(2,2,0)*df(3,0,0)+df(2,0,0)*df(3,2,0) ) &
         + gl(2,2,0,0)*two*df(3,0,0)*df(3,2,0)
 
   dA(1) = gl(3,3,2,0)*two*df(2,0,0)*df(2,2,0) + gl(3,3,0,0)*two*( df(2,2,0)*df(2,2,0) + df(2,0,0)*df(2,2,2) ) & 
         - two* ( gl(2,3,2,0)*( df(2,2,0)*df(3,0,0)+df(2,0,0)*df(3,2,0) ) + gl(2,3,0,0)*( df(2,2,2)*df(3,0,0)+two*df(2,2,0)*df(3,2,0)+df(2,0,0)*df(3,2,2) ) ) &
         + gl(2,2,2,0)*two*df(3,0,0)*df(3,2,0) + gl(2,2,0,0)*two*( df(3,2,0)*df(3,2,0) + df(3,0,0)*df(3,2,2) )

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!latex \be b_1 = g_{\phi\phi} f_{\theta}^2 - 2 g_{\theta\phi} f_{\theta} f_{\phi} + g_{\theta\theta} f_{\phi}^2, \ee

   db1(0) = gl(3,3,0,0)*df(2,0,0)**2 - two*gl(2,3,0,0)*df(2,0,0)*df(3,0,0) + gl(2,2,0,0)*df(3,0,0)**2
   db1(1) = gl(3,3,2,0)*df(2,0,0)**2 - two*gl(2,3,2,0)*df(2,0,0)*df(3,0,0) + gl(2,2,2,0)*df(3,0,0)**2 + dA(0)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   dabc(1,0) = gl(2,2,0,0)
   dabc(1,1) = gl(2,2,2,0)
 
   dabc(2,0) = -two * gl(2,3,0,0) * pt
   dabc(2,1) = -two * gl(2,3,2,0) * pt
   dabc(2,2) = -two * gl(2,3,0,0)
 
   dabc(3,0) = gl(3,3,0,0) * pt**2 - db1(0) - two * delta_p * dG(0)
   dabc(3,1) = gl(3,3,2,0) * pt**2 - db1(1) - two * delta_p * dG(1)
   dabc(3,2) = gl(3,3,0,0) * pt*two
   
   discrim=dabc(2,0)**2-four*dabc(1,0)*dabc(3,0)
   
   if( discrim.lt.zero ) stop "ph00aa :          : WF=? ; discrim.lt.zero ;"
 
   dP(0)  = ( -dabc(2,0) + plusminus *                                                                                   sqrt (discrim)                       ) / (two*dabc(1,0))
   dP(1)  = ( -dabc(2,1) + plusminus * half * (two*dabc(2,0)*dabc(2,1)-four*(dabc(1,1)*dabc(3,0)+dabc(1,0)*dabc(3,1))) / sqrt (discrim) - dP(0)*two*dabc(1,1) ) / (two*dabc(1,0))
   dP(2)  = ( -dabc(2,2) + plusminus * half * (two*dabc(2,0)*dabc(2,2)-four*(                    dabc(1,0)*dabc(3,2))) / sqrt (discrim)                       ) / (two*dabc(1,0))
  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !pphi=dP(0) ! returned through allglobal;

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!latex \be b_2 = g_{\phi\phi} p_{\theta}^2 - 2 g_{\theta\phi} p_{\theta} p_{\phi} + g_{\theta\theta} p_{\phi}^2, \ee

   db2(0) = gl(3,3,0,0)*   pt**2 - two*gl(2,3,0,0)* pt*dP(0)            + gl(2,2,0,0)*    dP(0)**2
   db2(1) = gl(3,3,2,0)*   pt**2 - two*gl(2,3,2,0)* pt*dP(0)            + gl(2,2,2,0)*    dP(0)**2 & 
                                 - two*gl(2,3,0,0)* pt*dP(1)            + gl(2,2,0,0)*two*dP(0)*dP(1)
   db2(2) = gl(3,3,0,0)*two*pt   - two*gl(2,3,0,0)*(   dP(0)+pt*dP(2) ) + gl(2,2,0,0)*two*dP(0)*dP(2)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   dtdot(0) = gl(3,3,0,0)*two*pt - two*gl(2,3,0,0)*dP(0)
   dtdot(1) = gl(3,3,2,0)*two*pt - two*gl(2,3,2,0)*dP(0) - two*gl(2,3,0,0)*dP(1)
   dtdot(2) = gl(3,3,0,0)*two                            - two*gl(2,3,0,0)*dP(2)
 
   dpdot(0) = -two*gl(2,3,0,0)*pt + gl(2,2,0,0)*two*dP(0)
   dpdot(1) = -two*gl(2,3,2,0)*pt + gl(2,2,2,0)*two*dP(0) + gl(2,2,0,0)*two*dP(1)
   dpdot(2) = -two*gl(2,3,0,0)                            + gl(2,2,0,0)*two*dP(2)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
   ftftptpt=df(2,0,0)**2-pt**2 ; ftfpptpp= df(2,0,0)*df(3,0,0)-pt*dP(0) ; fpfppppp=df(3,0,0)**2-dP(0)**2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   dsdot(0) = gl(3,3,2,0)* ftftptpt                 - two*gl(2,3,2,0)* ftfpptpp                                          + gl(2,2,2,0)*fpfppppp                              &
            + dA(0) + (db2(0)-db1(0))*dG(1)/dG(0)
 
   dsdot(1) = gl(3,3,2,2)* ftftptpt                 - two*gl(2,3,2,2)* ftfpptpp                                          + gl(2,2,2,2)*fpfppppp                              &
            + gl(3,3,2,0)*(two*df(2,0,0)*df(2,2,0)) - two*gl(2,3,2,0)*(df(2,2,0)*df(3,0,0)+df(2,0,0)*df(3,2,0)-pt*dP(1)) + gl(2,2,2,0)*two*(df(3,0,0)*df(3,2,0)-dP(0)*dP(1)) & 
            + dA(1) + (db2(1)-db1(1))*dG(1)/dG(0) + (db2(0)-db1(0))*(dG(2)-dG(1)**2/dG(0))/dG(0)
 
   dsdot(2) = gl(3,3,2,0)*(-two*pt)                 - two*gl(2,3,2,0)*(-dP(0)-pt*dP(2))                                  + gl(2,2,2,0)*(-two*dP(0)*dP(2))                    &
                    +  db2(2)        *dG(1)/dG(0) 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   dptt(1:2) = (/ dsdot(0) , dtdot(0) /) / dpdot(0)
 
   TM(1,1) = ( dsdot(2) - dptt(1)*dpdot(2) ) / dpdot(0) ! d radial / d radial ;
   TM(1,2) = ( dsdot(1) - dptt(1)*dpdot(1) ) / dpdot(0) ! d radial / d angle  ;
   TM(2,1) = ( dtdot(2) - dptt(2)*dpdot(2) ) / dpdot(0) ! d angle  / d radial ;
   TM(2,2) = ( dtdot(1) - dptt(2)*dpdot(1) ) / dpdot(0) ! d angle  / d angle  ;
 
   dptt(3)=TM(1,1)*ptt(3) + TM(1,2)*ptt(5) ! standard format;
   dptt(4)=TM(1,1)*ptt(4) + TM(1,2)*ptt(6)
   dptt(5)=TM(2,1)*ptt(3) + TM(2,2)*ptt(5)
   dptt(6)=TM(2,1)*ptt(4) + TM(2,2)*ptt(6)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  return
  
end subroutine ph00aa

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ph00aa_out(zeta,ptt)

  use inputlist, only : 
  use fileunits, only : ounit
  use allglobal, only : pi2nfp

  LOCALS

  REAL, intent(inout) :: zeta
  REAL, intent(in) :: ptt(6)
  
  zeta = zeta + pi2nfp ! next intermediate output location;

  return

end subroutine ph00aa_out

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

REAL function ph00aa_end(zeta,ptt)

  use allglobal, only : pi2nfp

  LOCALS

  REAL, intent(inout) :: zeta
  REAL, intent(in) :: ptt(6)
  
  ph00aa_end = zeta - pi2nfp ! integration termination;

  return

end FUNCTION ph00aa_end

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

