!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Description of equilibrium and compilation instructions.
!latex \heading{multi-region, relaxed MHD equilibria}
!latex \item Consider a plasma region comprised of a set of \mbox{$N_V \equiv$} \verb+Nvol+ nested annular regions, 
!latex which are separated by a discrete set of toroidal interfaces, \mbox{${\cal I}_l$}.
!latex We insist that the fields are tangential to the interfaces.
!latex In each volume, \mbox{${\cal V}_l$}, bounded by the \mbox{${\cal I}_{l-1}$} and \mbox{${\cal I}_l$} interfaces, 
!latex the plasma energy, \mbox{$U_l$}, the global-helicity, \mbox{$H_l$}, and the mass, \mbox{$M_l$}, are given by the integrals:
!latex \be U_l & = & \int_{{\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) dv, \label{eq:plasmaenergy}\\ 
!latex     H_l & = & \int_{{\cal V}_l} {\bf A} \cdot {\bf B} \; dv, \label{eq:helicity}\\
!latex     M_l & = & \int_{{\cal V}_l} p^{1/\gamma} \; dv, \label{eq:mass}\ee
!latex where \mbox{${\bf B}=\nabla \times {\bf A}$}.
!latex The pressure, \mbox{$p$}, is a scalar function of position.
!latex \item The equilibrium states that we seek minimize the total plasma energy, subject to the constraints of conserved helicity and conserved mass in each annular region.
!latex We allow arbitrary variations in the pressure in each annulus, $\delta p$, 
!latex the magnetic field in each annulus, \mbox{$\delta {\bf A}$}, and the geometry of the interfaces, $\boldxi$,
!latex except that we assume the magnetic field remains tangential to the interfaces which we consider to act as `ideal barriers'.
!latex
!latex The free-energy functional we seek to extremize is
!latex \be F = \sum_{l=1}^{N_V} \left( U_l - \mu_l H_l/2 - \nu_l M_l \right), \label{eq:constrainedenergyfunctional}
!latex \ee
!latex where \mbox{$\mu_l$} and \mbox{$\nu_l$} are Lagrange multipliers (and are constant over each volume, \mbox{${\cal V}_l$}).
!latex \item The first variation in the plasma energy,
!latex allowing variations in the pressure, \mbox{$\delta p$}, the field, \mbox{$\delta {\bf A}$}, and interface geometry, \mbox{$\boldxi$}, is given
!latex \be \delta U_l & = & \int_{{\cal V}_l} \left( \frac{\delta p}{\gamma-1} + \frac{{\bf B}\cdot \nabla \times \delta {\bf A}}{\mu_0} \right) dv
!latex                  +   \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi ) \; ds, \ee
!latex Using the identity $\nabla \cdot ({\bf A} \times {\bf B})={\bf B} \cdot \nabla \times {\bf A}-{\bf A} \cdot \nabla \times {\bf B}$ and integrating by parts we obtain
!latex \be \delta U_l   =   \int_{{\cal V}_l} \left( \frac{\delta p}{\gamma-1} + \frac{\delta {\bf A}\cdot \nabla \times {\bf B}}{\mu_0} \right) dv
!latex                  +   \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi) \; ds
!latex                  +   \int_{\partial {\cal V}_l} \frac{{\bf n}\cdot \delta {\bf A}\times{\bf B}}{\mu_0} \; ds. \ee
!latex The interfaces are assumed to be ideal, so in the surface integrals we make use of 
!latex Faraday's law \mbox{$\partial_t {\bf B}=\nabla\times{\bf E}$} and the
!latex ideal Ohm's law \mbox{${\bf E}+{\bf v}\times{\bf B}=0$} to obtain the expression $\delta {\bf A} = \boldxi \times {\bf B}$.
!latex The variation in the plasma energy becomes
!latex \be \delta U_l = \int_{{\cal V}_l} \left( \frac{\delta p}{\gamma-1} + \frac{\delta {\bf A}\cdot \nabla \times {\bf B}}{\mu_0} \right) dv
!latex                + \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} - \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi ) \; ds. \ee
!latex A similar analysis shows that the first variation in the helicity is
!latex \be \delta H_l & = & 2 \int_{{\cal V}_l} {\bf B} \cdot \delta {\bf A} \; dv. \ee
!latex The variation in the plasma mass is
!latex \be \delta M_l &=& \int_{{\cal V}_l} \frac{p^{1/\gamma}}{\gamma p} \delta p\;dv+\int_{\partial {\cal V}_l} p^{1/\gamma} ({\bf n}\cdot \boldxi ) \; ds. \nonumber \ee
!latex
!latex Combining these expressions, the first variation in the free-energy functional is
!latex \be \delta F_l & = & \int_{{\cal V}_l} \left(\frac{1}{\gamma-1} - \frac{\nu_l p^{1/\gamma}}{\gamma p}\right) \delta p \; dv \nonumber \\
!latex                & + & \int_{{\cal V}_l} \left( \frac{\nabla \times {\bf B}}{\mu_0}-\mu_l {\bf B} \right) \cdot \delta {\bf A} \; dv \label{eq:firstvariation} \\
!latex                & + & \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} - \nu_l p^{1/\gamma} - \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi ) \; ds
!latex \nonumber 
!latex \ee
!latex 
!latex The Euler-Lagrange equation for variations in the pressure is $\nu_l p^{1/\gamma} = \gamma p /(\gamma-1)$.
!latex For constant \mbox{$\nu_l$} this indicates that \mbox{$p=const.$} in each volume.
!latex 
!latex The Euler-Lagrange equation for variations in the variations in the vector-potential is the Beltrami equation, \Eqn{Beltrami}.
!latex \be \nabla \times {\bf B} = \mu_l \mu_0 {\bf B}. \label{eq:Beltrami} \ee
!latex 
!latex The Euler-Lagrange equation for variations in the interface geometry, using $\nu_l p^{1/\gamma} = \gamma p /(\gamma-1)$, is
!latex \be \Big[\!\Big[ p + B^2 / 2\mu_0 \Big]\!\Big]=0. \label{eq:ELgeometry} \ee
!latex The pressure may have discrete jumps at the interfaces, and so globally non-trivial pressure profiles may be constructed, 
!latex provided the total pressure, $p+B^2/2\mu_0$, is continuous.
!latex (An auxiliary analysis of the pressure-jump Hamiltonian indicates that the interfaces must have strongly irrational transform.)
!latex Only the variations in the geometry normal to the interfaces, \mbox{$({\bf n}\cdot \boldxi)$}, are relevant: 
!latex tangential variations do not alter the energy functional.
!latex To constrain the tangential degrees of freedom, additional constraints derived from minimizing the spectral width are included.

!latex \heading{numerical descretization}

!latex \item A set of \mbox{$N_V$} nested, toroidal surfaces is given on input.
!latex For expedience, we restrict attention to stellarator symmetric devices \cite{Dewar_Hudson_97b} so that the interfaces may be described
!latex \be \begin{array}{ccc} R_l(\theta,\zeta)&=&\sum_{j}R_{l,j}\cos(m_j \t -n_j \z),\\
!latex                        Z_l(\theta,\zeta)&=&\sum_{j}Z_{l,j}\sin(m_j \t -n_j \z). \end{array} \label{eq:stellaratorsymmetricgeometry} \ee
!latex \item The coordinate functions \mbox{$R(\s,\t,\z)$} and \mbox{$Z(\s,\t,\z)$} take the form
!latex \be \begin{array}{ccc} R(\s,\t,\z)&=&\sum_j R_j(\s)\cos(m_j\theta-n_j\zeta), \\
!latex                        Z(\s,\t,\z)&=&\sum_j Z_j(\s)\sin(m_j\theta-n_j\zeta), \end{array} \ee
!latex where the functions \mbox{$R_j(\s)$}, \mbox{$Z_j(\s)$} are constructed by piecewise-cubic interpolation of the \mbox{$R_{l,j}$} and \mbox{$Z_{l,j}$}.
!latex \item In the \mbox{$l$}-th annulus, bounded by the \mbox{$(l-1)$}-th and \mbox{$l$}-th interfaces, 
!latex a general covariant representation of the magnetic vector-potential is written
!latex \be {\bf \bar A}_l=\bar A_{s,l} \nabla s + \bar A_{\t,l} \nabla \t + \bar A_{\z,l} \nabla \z. \ee
!latex To this add \mbox{$\nabla g_l(s,\t,\z)$}, where $g_l$ satisfies
!latex \be \begin{array}{ccl} \partial_\s g_l(\s      ,\t,\z) & = & - \bar A_{\s,l}(\s      ,\t,\z)             ,\\
!latex                        \partial_\t g_l(\s_{l-1},\t,\z) & = & - \bar A_{\t,l}(\s_{l-1},\t,\z)+\psi_{t,l-1},\\
!latex                        \partial_\z g_l(\s_{l-1}, 0,\z) & = & - \bar A_{\z,l}(\s_{l-1}, 0,\z)+\psi_{p,l-1},\end{array} \ee
!latex for arbitrary constants \mbox{$\psi_{t,l-1}$}, \mbox{$\psi_{p,l-1}$}, which are the toroidal and poloidal-fluxes on the interior of surface \mbox{$l-1$}.
!latex Then \mbox{${\bf A}_l={\bf \bar A}_l+\nabla g_l$} is given by \mbox{${\bf A}_l=A_{\theta,l}\nabla\t+A_{\zeta,l}\nabla\z$} with
!latex \be \begin{array}{ccc} A_{\theta,l}(\s_{l-1},\t,\z)&=&\psi_{t,l-1}, \\
!latex                        A_{\zeta,l}(\s_{l-1}, 0,\z) &=&\psi_{p,l-1}. \end{array} \label{eq:gauge} \ee
!latex This specifies the gauge.
!latex \item For stellarator symmetric equilibria, \mbox{$A_{\theta,l}$} and \mbox{$A_{\zeta,l}$} may be represented by cosine series
!latex \be \begin{array}{ccc} A_{\theta,l}(s,\t,\z)=\sum_{j}A_{\theta,l,j}(s)\cos(m_j\t-n_j\z),\\
!latex                        A_{\zeta,l}(s,\t,\z)=\sum_{j}A_{\zeta,l,j}(s)\cos(m_j\t-n_j\z), \end{array} \ee
!latex where \mbox{$A_{\theta,l,j}(s)$} and \mbox{$A_{\zeta,l,j}(s)$} are represented using finite-elements.

!latex \heading{compilation}
!latex \item The source is kept under CVS: \verb+>cvs -d /u/shudson/cvs_Spec/ checkout Spec+
!latex \item Compilation is provided by a Makefile: \verb+>make xspec+. Try \verb+>make help+ for compilation options.
!latex \begin{enumerate}
!latex \item The compilation flags are given by \verb+FLAGS+. These may be over-ruled by command line arguments.
!latex \item Compilation flags must be set that convert single precision to double precision, e.g. \verb+make FLAGS="--dbl"+.
!latex \item The NAG library is used and must be correctly linked.
!latex \end{enumerate}

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine readme


end subroutine readme

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
