!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Performs radial interpolation of vector potential harmonics.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine sa00aa( lss )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one
  use numerical, only : vsmall
  use fileunits, only : ounit
  use inputlist, only : Wsa00aa, Ni, Nofe
  use cputiming, only : Tsa00aa
  use allglobal, only : myid, mn, im, in, ll, ss, dss, rho, At, Az, cpus, Atmn, Azmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  REAL, intent(inout) :: lss

  INTEGER          :: ii, ij, il, ip, imn, mm
  REAL             :: xx, varphi(0:1,0:3,0:2)

  BEGIN(sa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(sa00aa,Nofe.gt.3,need to change dimensions of varphi if higher order finite-element basis functions are employed)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wsa00aa ) then ; cput = MPI_WTIME() ; write(ounit,'("sa00aa : "f10.2" : ll="i3" ; [s_{l-1},lss,s_{l}]="3es23.15" ;")')cput-cpus,ll,ss(ll)%s(0),lss,ss(ll)%s(Ni(ll))
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(sa00aa,lss.lt.ss(ll)%s(0),radial coordinate outside local bounds)
  FATALMESS(sa00aa,lss.gt.ss(ll)%s(Ni(ll)),radial coordinate outside local bounds)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  ii = ( lss - ss(ll)%s(0) ) / dss(ll,1) ! left grid point;

  if( Wsa00aa ) write(ounit,'("sa00aa : "f10.2" : ll="i3" ; ii="i3" ; [s_{l,i},lss,s_{l,i+1}]="3es23.15" ;")')cput-cpus,ll,ii,ss(ll)%s(ii),lss,ss(ll)%s(ii+1)

  FATALMESS(sa00aa,ii.lt.0,local interpolation variable outside bounds)
  
  if( ii.eq.Ni(ll) ) ii = ii-1 ! keep off outer boundary; see ii+il logic below;

  FATALMESS(sa00aa,ii.ge.Ni(ll),local interpolation variable outside bounds)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  xx = ( lss - ss(ll)%s(ii) ) / dss(ll,1) ! local interpolation;

  if( Wsa00aa ) write(ounit,'("sa00aa : "f10.2" : ll="i3" ; ii="i3" ; xx="es23.15" ;")')cput-cpus,ll,ii,xx

  FATALMESS(sa00aa,xx.lt.zero-vsmall.or.xx.gt.one+vsmall,local interpolation variable outside bounds)

  if( xx.lt.zero ) xx = zero ! must be due to finite precision given above check on input value of lss;
  if( xx.gt.one  ) xx = one  ! must be due to finite precision given above check on input value of lss;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Atmn(0:2,1:mn) = zero ; Azmn(0:2,1:mn) = zero

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( ll.eq.1 .and. ii.eq.0 ) then

   FATALMESS(sa00aa,lss.lt.zero .or. lss.gt.rho,incorrect interpolation logic)
   
   do imn = 1,mn ; ij = imn ; mm = im(ij)
    do ip = 0 , Nofe
                            Atmn(0,imn) = Atmn(0,imn) + At(ll,ij,ip)%s(0) * lss**( mm+2+2*ip   )
                            Atmn(1,imn) = Atmn(1,imn) + At(ll,ij,ip)%s(0) * lss**( mm+2+2*ip-1 ) * ( mm+2+2*ip )
                            Atmn(2,imn) = Atmn(2,imn) + At(ll,ij,ip)%s(0) * lss**( mm+2+2*ip-2 ) * ( mm+2+2*ip ) * ( mm+2+2*ip-1 )

                            Azmn(0,imn) = Azmn(0,imn) + Az(ll,ij,ip)%s(0) * lss**( mm+0+2*ip   )
     if( mm+0+2*ip-1.ge.0 ) Azmn(1,imn) = Azmn(1,imn) + Az(ll,ij,ip)%s(0) * lss**( mm+0+2*ip-1 ) * ( mm+0+2*ip )
     if( mm+0+2*ip-2.ge.0 ) Azmn(2,imn) = Azmn(2,imn) + Az(ll,ij,ip)%s(0) * lss**( mm+0+2*ip-2 ) * ( mm+0+2*ip ) * ( mm+0+2*ip-1 )
    enddo
   enddo

   goto 9999

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(sa00aa,lss.lt.rho-vsmall,incorrect interpolation logic)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The routine \verb+fe00ab+ is called to perform the basis function interpolation.

  ADDCPU(sa00aa)

  CALL(fe00ab,(xx,Nofe,varphi)) ! xx is the local interpolation coordinate; 

  RESETCPU

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The interpolated harmonics and the first and second radial derivatives are returned through the global arrays \verb+Atmn(0:2,1:mn)+ and \verb+Azmn(0:2,1:mn)+.

  do imn = 1 , mn ; ij = imn ! loop over Fourier harmonics;
   do ip = 0 , Nofe ! order of derivative;
    do il = 0 , 1 ! left/right;
     
     FATALMESS(sa00aa,ii+il.gt.Ni(ll),sub-grid indexing error on At and Az)

     Atmn(0,imn) = Atmn(0,imn) + At(ll,ij,ip)%s(ii+il) * varphi(il,ip,0) * dss(ll,ip  )
     Atmn(1,imn) = Atmn(1,imn) + At(ll,ij,ip)%s(ii+il) * varphi(il,ip,1) * dss(ll,ip-1)
     Atmn(2,imn) = Atmn(2,imn) + At(ll,ij,ip)%s(ii+il) * varphi(il,ip,2) * dss(ll,ip-2)

     Azmn(0,imn) = Azmn(0,imn) + Az(ll,ij,ip)%s(ii+il) * varphi(il,ip,0) * dss(ll,ip  )
     Azmn(1,imn) = Azmn(1,imn) + Az(ll,ij,ip)%s(ii+il) * varphi(il,ip,1) * dss(ll,ip-1)
     Azmn(2,imn) = Azmn(2,imn) + Az(ll,ij,ip)%s(ii+il) * varphi(il,ip,2) * dss(ll,ip-2)

    enddo ! do il = 0 , 1 ;
   enddo ! end of do ip = 0 , Nofe;
  enddo ! end of do imn = 1 , mn;
  
 !if( Wsa00aa ) then
 ! cput = MPI_WTIME()
 ! do imn = 1,mn
 !  write(ounit,'("sa00aa : "f10.2" : myid="i3" ; ll="i3" ; (im,in)=("i4", "i4" ) ; Atmn(0:2)="3es23.15" , Azmn(0;2)="3es23.15" ;")')&
 !cput-cpus,myid,ll,im(imn),in(imn),Atmn(0:2,imn),Azmn(0:2,imn)
 ! enddo
 !endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(sa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine sa00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
