!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Unpacks solution vector from Beltrami linear system solver into vector potential.
!latex (Primarily called by \verb+mp00aa+.)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine up00aa( lNBdof , xi )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wup00aa, Ni, Nofe, tflux
  use cputiming, only : Tup00aa
  use allglobal, only : myid, cpus, mn, im, in, ll, At, Az, dtflux, dpflux, Ajpq, Bjpq, rho

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lNBdof
  REAL   , intent(in) :: xi(1:lNBdof)

  INTEGER             :: ii, ij, ip, iq, rm, rn, mm, nn

  BEGIN(up00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  select case(ll)
   
  case(1)
   
   do ii = 0 , Ni(ll) ! unpacking solution vector;
    do ij = 1 , mn ; mm = im(ij) ; nn = in(ij)
     do ip = 0 , Nofe
      
      rm = 1 ; rn = 1 ! default, independent degree of freedom; at outer interface the At and Az are dependent;
      
      At(ll,ij,ip)%s(ii) = zero ; Az(ll,ij,ip)%s(ii) = zero
      
      if( ii.eq.0 ) then ! coordinate origin;

        FATALMESS(up00aa,At(ll,ij,ip)%i(ii).lt.1 .or. At(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
        At(ll,ij,ip)%s(ii) = xi( At(ll,ij,ip)%i(ii) ) / rho**( mm ) ! unpacking degrees of freedom;

       if( ip.eq.0 ) then
        Az(ll,ij,ip)%s(ii) = zero
       else
        FATALMESS(up00aa,Az(ll,ij,ip)%i(ii).lt.1 .or. Az(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
        Az(ll,ij,ip)%s(ii) = xi( Az(ll,ij,ip)%i(ii) ) / rho**( mm ) ! unpacking degrees of freedom;
       endif
       
      endif
      
      if( ii.eq.1 ) then ! first grid point = matching grid point;

       do iq = 0 , Nofe

        FATALMESS(up00aa,At(ll,ij,iq)%i(0).lt.1 .or. At(ll,ij,iq)%i(0).gt.lNBdof,need to check dimension of xi)
        At(ll,ij,ip)%s(ii) = At(ll,ij,ip)%s(ii) + Ajpq(ij,ip,iq) * xi( At(ll,ij,iq)%i(0) )

        if( iq.gt.0 ) then
        FATALMESS(up00aa,Az(ll,ij,iq)%i(0).lt.1 .or. Az(ll,ij,iq)%i(0).gt.lNBdof,need to check dimension of xi)
        Az(ll,ij,ip)%s(ii) = Az(ll,ij,ip)%s(ii) + Bjpq(ij,ip,iq) * xi( Az(ll,ij,iq)%i(0) )
        endif

       enddo ! end of do iq;

      endif ! end of if( ii.eq.1 );
      
      if( ii.gt.1 .and. At(ll,ij,ip)%i(ii).ne.0 ) then
       if( ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) rm =  mm ! not an independent degree of freedom;
       FATALMESS(up00aa,At(ll,ij,ip)%i(ii).lt.1 .or. At(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
       At(ll,ij,ip)%s(ii) = rm * xi( At(ll,ij,ip)%i(ii) ) ! unpacking degrees of freedom;
      endif
      
      if( ii.gt.1 .and. Az(ll,ij,ip)%i(ii).ne.0 ) then
       if( ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) rn = -nn ! not an independent degree of freedom;
       FATALMESS(up00aa,Az(ll,ij,ip)%i(ii).lt.1 .or. Az(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
       Az(ll,ij,ip)%s(ii) = rn * xi( Az(ll,ij,ip)%i(ii) ) ! unpacking degrees of freedom;
      endif
      
     enddo ! end of do ip;
    enddo ! end of do ij;
   enddo ! end of do ii;
   
   ii = Ni(ll) ; ij = 1 ; ip = 0 ; At(ll,ij,ip)%s(ii) = dtflux(ll) ; Az(ll,ij,ip)%s(ii) = dpflux(ll) ! include inhomogeneous boundary terms;
   
  case(2:)
   
   do ii = 0 , Ni(ll) ! unpacking solution vector;
    do ij = 1 , mn ; mm = im(ij) ; nn = in(ij)
     do ip = 0 , Nofe
      
      rm = 1 ; rn = 1 ! default, independent degree of freedom;
      
      At(ll,ij,ip)%s(ii) = zero ; Az(ll,ij,ip)%s(ii) = zero
      
      if( At(ll,ij,ip)%i(ii).ne.0 ) then
       if( ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) rm =  mm ! not an independent degree of freedom;
       FATALMESS(up00aa,At(ll,ij,ip)%i(ii).lt.1 .or. At(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
       At(ll,ij,ip)%s(ii) = rm * xi( At(ll,ij,ip)%i(ii) ) ! unpacking degrees of freedom;
      endif
      
      if( Az(ll,ij,ip)%i(ii).ne.0 ) then
       if( ii.eq.Ni(ll) .and. ij.gt.1 .and. ip.eq.0 ) rn = -nn ! not an independent degree of freedom;
       FATALMESS(up00aa,Az(ll,ij,ip)%i(ii).lt.1 .or. Az(ll,ij,ip)%i(ii).gt.lNBdof,need to check dimension of xi)
       Az(ll,ij,ip)%s(ii) = rn * xi( Az(ll,ij,ip)%i(ii) ) ! unpacking degrees of freedom;
      endif
      
     enddo ! end of do ip;
    enddo ! end of do ij;
   enddo ! end of do ii;
   
   ii = Ni(ll) ; ij = 1 ; ip = 0 ; At(ll,ij,ip)%s(ii) = dtflux(ll) ; Az(ll,ij,ip)%s(ii) = dpflux(ll)
   
  case default
   
   FATALMESS(up00aa,.true.,invalid logic)
   
  end select
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(up00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine up00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
